zoukankan      html  css  js  c++  java
  • HDU 4336 Card Collector(概率DP,状态压缩)

    Card Collector

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 1405    Accepted Submission(s): 624
    Special Judge


    Problem Description
    In your childhood, do you crazy for collecting the beautiful cards in the snacks? They said that, for example, if you collect all the 108 people in the famous novel Water Margin, you will win an amazing award.

    As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.
     
    Input
    The first line of each test case contains one integer N (1 <= N <= 20), indicating the number of different cards you need the collect. The second line contains N numbers p1, p2, ..., pN, (p1 + p2 + ... + pN <= 1), indicating the possibility of each card to appear in a bag of snacks.

    Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.
     
    Output
    Output one number for each test case, indicating the expected number of bags to buy to collect all the N different cards.

    You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.
     
    Sample Input
    1 0.1 2 0.1 0.4
     
    Sample Output
    10.000 10.500
     
    Source
     
    Recommend
    zhoujiaqi2010
     
     
    状态压缩概率DP,或者是容斥原理、
    /*
    HDU 4336
    题意:
    有N(1<=N<=20)张卡片,每包中含有这些卡片的概率为p1,p2,````pN.
    每包至多一张卡片,可能没有卡片。
    求需要买多少包才能拿到所以的N张卡片,求次数的期望。
    
    
    可以用容斥原理做。也可以状态压缩进行概率DP
    期望DP
    */
    #include<stdio.h>
    #include<algorithm>
    #include<iostream>
    #include<string.h>
    using namespace std;
    const int MAXN=22;
    double p[MAXN];
    double dp[1<<MAXN];
    int main()
    {
        int n;
        while(scanf("%d",&n)!=EOF)
        {
            double tt=0;
            for(int i=0;i<n;i++)
            {
                scanf("%lf",&p[i]);
                tt+=p[i];
            }
            tt=1-tt;//tt就表示没有卡片的概率了
            dp[(1<<n)-1]=0;
            for(int i=(1<<n)-2;i>=0;i--)
            {
                double x=0,sum=1;
                for(int j=0;j<n;j++)
                {
                    if((i&(1<<j)))x+=p[j];
                    else sum+=p[j]*dp[i|(1<<j)];
                }
                dp[i]=sum/(1-tt-x);
            }
            printf("%.5lf\n",dp[0]);
    
        }
        return 0;
    }
    /*
    HDU 4336
    容斥原理
    位元素枚举
    */
    #include<stdio.h>
    #include<string.h>
    #include<iostream>
    #include<algorithm>
    using namespace std;
    
    double p[22];
    int main()
    {
        int n;
        while(scanf("%d",&n)==1)
        {
            for(int i=0;i<n;i++)scanf("%lf",&p[i]);
            double ans=0;
            for(int i=1;i<(1<<n);i++)
            {
                int cnt=0;
                double sum=0;
                for(int j=0;j<n;j++)
                  if(i&(1<<j))
                  {
                      sum+=p[j];
                      cnt++;
                  }
                if(cnt&1)ans+=1.0/sum;
                else ans-=1.0/sum;
            }
            printf("%.5lf\n",ans);
        }
        return 0;
    }
    人一我百!人十我万!永不放弃~~~怀着自信的心,去追逐梦想
  • 相关阅读:
    python中的pip
    代码块
    Java 中的main方法
    mysql的decimal(10,0) not null问题
    vue 超大 table
    apache2 的https配置和代理https后端nodejs配置
    3分钟解决MySQL 1032 主从错误(转)
    CentOS 7 Apache服务的安装与配置(转)
    mybatis pagehelper多数据源配置的坑
    web worker的用法及应用场景(转)
  • 原文地址:https://www.cnblogs.com/kuangbin/p/2713089.html
Copyright © 2011-2022 走看看